/*+----------------------------------------------------+
  | Inversao de imagem binaria ou em niveis de cinza   |
  +----------------------------------------------------+*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "imagem.h"
#include "morfo.h"
#include "utils.h"


void msg (void) {
    printf ("\nINVERSAO de uma imagem qualquer");
    printf ("\n-------------------------------\n");
    printf ("Opcoes:\n");
    printf ("    <NOME.PGM>  Arquivo da imagem em formato PBM ou PGM\n\n");
}

/*+------------------------------------------------------+
  |        P R O G R A M A    P R I N C I P A L          |
  +------------------------------------------------------+*/
void main (int argc, char *argv[]) {
  int OK, nc, nl, mn, tipo_img;
  int *I, *O;
  OK = FALSE;
  if (argc == 2){
      if (strstr (argv [1],".pbm")) {
         OK = le_imagem_pbm (argv[1], &I, &nl, &nc);
         mn  = 1;
	 tipo_img = 1;
      } else {
         OK = le_imagem_pgm (argv[1], &I, &nl, &nc, &mn);
	 tipo_img = 2;
      }
  }
  else msg ();
  if (OK) {
      printf ("\nINVERSAO DE IMAGEM");
      info_imagem (argv[1], nl, nc, mn);
      aloca_memo (&O, nl, nc);
      inverte (I, O, nl, nc, mn);
      if (tipo_img == 1) {
         grava_imagem_pbm (O, "inverte.pbm", nl, nc);
//	 system ("xv inverte.pbm &");
      }
      if (tipo_img == 2) {
	 grava_imagem_pgm (O, "inverte.pgm", nl, nc, mn);
//   /*      system ("xv inverte.pgm &"); */
      }
      desaloca_memo (&I);
      desaloca_memo (&O);
  }
}
